!---------------------------------------------------------------------!
!  Mo(mentum)Re(summed)-SusHi:                                        !
!  Calculation of resummed transverse momentum distribution of gg->H  !
!                                                                     !
!  This file is main file                                             !
!  written by Hendrik Mantler and Marius Wiesemann                    !
!  Version 1.3.0                                                      !
!---------------------------------------------------------------------!
      PROGRAM MoReSusHi
      implicit none
      include 'Commons/common-output.f'
      integer outlen,strlen
      CALL initial()      
      CALL moresushi_calc()
      outlen=strlen(outfile)  
      IF(outfile == 'out.moresushi') THEN
         print*,' '
         CALL printinfo('Output written to default: '
     f     //outfile(1:outlen)//'(_*)')
         ELSE 
         CALL printinfo('Output written to files: '
     f     //outfile(1:outlen)//'(_*)')
      ENDIF
      END
      

