C-{{{ subroutine: moresushi_calc

      SUBROUTINE moresushi_calc()
      implicit none 
      INTEGER orderSAVE
      include 'Commons/common-chankeys.f'
      include 'Commons/common-results.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-output.f'
      include 'Commons/vars-output.f'
      DOUBLE PRECISION fo_gg,err_fo_gg,el_gg,err_el_gg,res_gg,err_res_gg
     f ,fo_gq,err_fo_gq,el_gq,err_el_gq,res_gq,err_res_gq 
     f ,fo_qq,err_fo_qq,el_qq,err_el_qq,res_qq,err_res_qq
     f ,fo,err_fo,el,err_el,res,err_res 

      if(verbosept.ne.0) print*,' '
      if(verbosept.ne.0) write(40,*),' '

!      CALL initial_Itilde(pTH/Qres)
      IF(ggkey.eq.1 .and. gqkey.eq.1 .and. qqkey.eq.1) THEN
      if(verbosept.ne.0)then
         print*, '****************(  all channels  )*****************'
      endif
      WRITE(40,*)'****************(  all channels  )*****************'
      CALL all_channel(N,fo,err_fo,el,err_el,res,err_res)
      ELSE

      if (ggkey.eq.1) then
      if(verbosept.ne.0)then
         print*, '********************(  gg->Hj  )*******************'
      endif
      WRITE(40,*)'********************(  gg->Hj  )*******************'
      CALL gg_chan(N,fo_gg,err_fo_gg,el_gg,err_el_gg,res_gg,err_res_gg)
      endif

      if (gqkey.eq.1) then
      if(verbosept.ne.0)then
         print*, '********************(  gq->Hj  )*******************'
      endif
      WRITE(40,*)'********************(  gq->Hj  )*******************'
      CALL gq_chan(N,fo_gq,err_fo_gq,el_gq,err_el_gq,res_gq,err_res_gq)
      endif

      if (qqkey.eq.1) then
      if(verbosept.ne.0)then
         print*, '********************(  qq->Hj  )*******************'
      endif
      WRITE(40,*)'********************(  qq->Hj  )*******************'
      CALL qq_chan(N,fo_qq,err_fo_qq,el_qq,err_el_qq,res_qq,err_res_qq)
      endif
      ENDIF
     
999   FORMAT(F7.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X
     f ,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,
     f F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,
     f F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3
     f ,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3,1X,F10.7,1X,E10.3
     f ,1X,F10.7,1X,E10.3)
      END

C-}}}
C-{{{ subroutine: all_chan

      SUBROUTINE all_channel(N,fixord,err_fo,log_exp,err_le,res,err_res)
      implicit none
      DOUBLE PRECISION fixord,err_fo,log_exp,err_le,res,err_res
     f ,res_err,XL,XU,acc,chi2,integral_match,integral_switch
     f ,matched,switched,integral_match_gg,integral_switch_gg 
     f ,matched_gg,switched_gg,integral_match_gq,integral_switch_gq 
     f ,matched_gq,switched_gq,integral_match_qq,integral_switch_qq 
     f ,matched_qq,switched_qq 
     f ,Shad,Hmass,Hmin,pTH,mV,mT,mb,muF,muRen,Qres,muFFO,muRenFO
     f ,result,result_gg,result_gq,result_qq,err_result,err_result_gg
     f ,err_result_gq,err_result_qq,logs_LO,logs_LO_gg,logs_LO_gq
     f ,logs_LO_qq,resummed,resummed_gg,resummed_gq,resummed_qq
     f ,res_err_gg,res_err_gq,res_err_qq,err_sum
      INTEGER N,ndim,ncall,ncall1,itmx,nprn,itmx1,orderSAVE,i,N_dum
     f ,strlen,runscale
      COMMON/BVEG1/XL(10),XU(10),acc,ndim,ncall,itmx,nprn
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-output.f'
      COMMON /IntVars/ Shad,Hmass,Hmin,pTH,mV,mT,mb,N_dum
      COMMON /ScaleVars/ muF,muRen,Qres,muFFO,muRenFO,runscale
      external LO_gq,LO_qq,res_LO_gq,LO_gg,res_LO_gg
      
      integral_match     = 0d0
      integral_switch    = 0d0
      integral_match_gg  = 0d0
      integral_switch_gg = 0d0
      integral_match_gq  = 0d0
      integral_switch_gq = 0d0
      integral_match_qq  = 0d0
      integral_switch_qq = 0d0
      IF(bins) THEN
         pTH = pT_Hmin
      ELSE
         pT_Hmax=pTH+1
         stepsize=2
      ENDIF
      call ParameterOUTandERR()


      OPEN(20,file=outfile,ACCESS='APPEND')   
      OPEN(21,file=outfile_gg,ACCESS='APPEND')   
      OPEN(22,file=outfile_gq,ACCESS='APPEND')   
      OPEN(23,file=outfile_qq,ACCESS='APPEND')   
      if(order.eq.1) then
      write(20,80) '# pT_H  ','Res_NLL     ','Res_NLO     '
     f ,'NLO         ','NLO+NLL     ','switched      '
      write(21,80) '# pT_H  ','Res_NLL     ','Res_NLO     '
     f ,'NLO         ','NLO+NLL     ','switched      '
      write(22,80) '# pT_H  ','Res_NLL     ','Res_NLO     '
     f ,'NLO         ','NLO+NLL     ','switched      '
      write(23,80) '# pT_H  ','Res_NLL     ','Res_NLO     '
     f ,'NLO         ','NLO+NLL     ','switched      '
      elseif(order.eq.2)then
      write(20,80) '# pT_H  ','Res_NNLL    ','Res_NNLO    '
     f ,'NNLO        ','NNLO+NNLL   ','switched      '
      write(21,80) '# pT_H  ','Res_NNLL    ','Res_NNLO    '
     f ,'NNLO        ','NNLO+NNLL   ','switched      '
      write(22,80) '# pT_H  ','Res_NNLL    ','Res_NNLO    '
     f ,'NNLO        ','NNLO+NNLL   ','switched      '
      write(23,80) '# pT_H  ','Res_NNLL    ','Res_NNLO    '
     f ,'NNLO        ','NNLO+NNLL   ','switched      '
      endif
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)

      do 1 while (pTH <= pT_Hmax)
      write(*,*)'           #-------------------------#'
      write(40,*)'           #-------------------------#'
      write (*, 3333) '# pT_H     = ', pTH, ' GeV #'
      write (40, 3333) '# pT_H     = ', pTH, ' GeV #'

      IF(runscale .eq. 1) THEN
         muFFO   = dsqrt(Hmass**2 + pTH**2) * muF/Hmass
         muRenFO = dsqrt(Hmass**2 + pTH**2) * muRen/Hmass
         CALL runCouplings(muRen,muRenFO)
         if(verbosept.ne.0)then
            write (*, 3333) '# mu_F     = ', muFFO, ' GeV #'
            write (*, 3333) '# mu_R     = ', muRenFO, ' GeV #'
            write (40, 3333) '# mu_F     = ', muFFO, ' GeV #'
            write (40, 3333) '# mu_R     = ', muRenFO, ' GeV #'
         endif
      ENDIF
      write(*,*)'           #-------------------------#'
      write(40,*)'           #-------------------------#'
      if(verbosept.ne.0)write(*,*)' '
      if(verbosept.ne.0)write(40,*)' '

      OPEN(20,file=outfile,ACCESS='APPEND')   
      OPEN(21,file=outfile_gg,ACCESS='APPEND')   
      OPEN(22,file=outfile_gq,ACCESS='APPEND')   
      OPEN(23,file=outfile_qq,ACCESS='APPEND')   

!---  evalutation NLO pT distribution
      result_gg = 0d0
      result_gq = 0d0
      result_qq = 0d0
      call integrate(LO_gg,2,N*10,10,result_gg,err_result_gg,chi2)
      WRITE(40,1234) 'NLO (gg):      ',result_gg,'+/-',err_result_gg
      call integrate(LO_gq,2,N*10,10,result_gq,err_result_gq,chi2)
      WRITE(40,1234) 'NLO (gq):      ',result_gq,'+/-',err_result_gq
      call integrate(LO_qq,2,N*10,10,result_qq,err_result_qq,chi2)
      WRITE(40,1234) 'NLO (qq):      ',result_qq,'+/-',err_result_qq
      result  = result_gg+result_gq+result_qq
      err_sum =dsqrt(err_result_gg**2+err_result_gq**2+err_result_qq**2)
      if(verbosept.ne.0) then
         WRITE(*,1234)'NLO (gg):      ',result_gg,'+/-',err_result_gg
         WRITE(*,1234)'NLO (gq):      ',result_gq,'+/-',err_result_gq
         WRITE(*,1234)'NLO (qq):      ',result_qq,'+/-',err_result_qq
      endif
      if(order .eq. 1) then
!---  evalutation NLO fixed order logarithms
      CALL initial_Itilde(pTH/Qres)
      call initrescoeff()
      logs_LO_gg = 0d0
      logs_LO_gq = 0d0
      logs_LO_qq = 0d0
      call integrate(res_LO_gg,2,N*3,10,logs_LO_gg,err_result_gg,chi2)
      WRITE(40,1234) 'Res_NLO (gg):  ',logs_LO_gg,'+/-',err_result_gg
      call integrate(res_LO_gq,2,N*3,10,logs_LO_gq,err_result_gq,chi2)
      WRITE(40,1234) 'Res_NLO (gq):  ',logs_LO_gq,'+/-',err_result_gq
      logs_LO = logs_LO_gg + logs_LO_gq
      err_sum =dsqrt(err_sum**2+err_result_gg**2+err_result_gq**2)
      if(verbosept.ne.0) then
         WRITE(*,1234)'Res_NLO (gg):  ',logs_LO_gg,'+/-',err_result_gg
         WRITE(*,1234)'Res_NLO (gq):  ',logs_LO_gq,'+/-',err_result_gq
      endif

!---  evalutation NLL resummed logarithms
      resummed_gg = 0d0
      resummed_gq = 0d0
      resummed_qq = 0d0
      chan = 2 ! 1(all)/2(gg)/3(gq)/4(qq)
      gg_or_qq = 1
      CALL get_resummed(1,resummed_gg,res_err_gg) 
      WRITE(40,1234)'Res_NLL (gg):  ',resummed_gg!,'  +/-',res_err_gg
      chan = 3 ! 1(all)/2(gg)/3(gq)/4(qq)
      gg_or_qq = 1
      CALL get_resummed(1,resummed_gq,res_err_gq) 
      WRITE(40,1234)'Res_NLL (gq):  ',resummed_gq!,'  +/-',res_err_gq
      WRITE(40,*) ' '
      resummed = resummed_gg+resummed_gq
      if(verbosept.ne.0) then
         WRITE(*,1234)'Res_NLL (gg):  ',resummed_gg!,'  +/-',res_err_gg
         WRITE(*,1234)'Res_NLL (gq):  ',resummed_gq!,'  +/-',res_err_gq
      endif

      matched = result - logs_LO + resummed
      if(verbosept.ne.0) then
         WRITE(*,1234)'NLO+NLL (all): ',matched,'+/-',err_sum
         WRITE(*,*) ' '
      endif
      matched_gg = result_gg - logs_LO_gg + resummed_gg
      matched_gq = result_gq - logs_LO_gq + resummed_gq
      matched_qq = result_qq - logs_LO_qq + resummed_qq
      switched_qq = result_qq
      if(pTH .gt. Hmass*2d0) then
         switched = result
      elseif(pTH.gt.Hmass*0.5d0.and.(resummed-logs_LO).lt.0d0)then
         switched = result
      else
         switched=matched
      endif
      if(pTH .gt. Hmass*2d0) then
         switched_gg = result_gg
      elseif(pTH.gt.Hmass*0.5d0.and.(resummed_gg-logs_LO_gg).lt.0d0)then
         switched_gg = result_gg
      else
         switched_gg=matched_gg
      endif
      if(pTH .gt. Hmass*2d0) then
         switched_gq = result_gq
      elseif(pTH.gt.Hmass*0.5d0.and.(resummed_gq-logs_LO_gq).lt.0d0)then
         switched_gq = result_gq
      else
         switched_gq=matched_gq
      endif


      IF(bins) THEN
      integral_match = integral_match + matched * stepsize
      integral_switch = integral_switch + switched * stepsize
      integral_match_gg = integral_match_gg + matched_gg * stepsize
      integral_switch_gg = integral_switch_gg + switched_gg * stepsize
      integral_match_gq = integral_match_gq + matched_gq * stepsize
      integral_switch_gq = integral_switch_gq + switched_gq * stepsize
      integral_match_qq = integral_match_qq + matched_qq * stepsize
      integral_switch_qq = integral_switch_qq + switched_qq * stepsize
      ENDIF
      write(20,90) pTH,resummed,logs_LO,result,matched,switched
      write(21,90) pTH,resummed_gg,logs_LO_gg,result_gg,matched_gg
     f ,switched_gg
      write(22,90) pTH,resummed_gq,logs_LO_gq,result_gq,matched_gq
     f ,switched_gq
      write(23,90) pTH,resummed_qq,logs_LO_qq,result_qq,matched_qq
     f ,switched_qq
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
      
      elseif(order .eq. 2) then
         call printstop('order=2, but NNLO+NNLL not working yet!')
!---  evalutation NNLO pT distribution
!---  evalutation NNLO fixed order logarithms
!---  evalutation NNLL resummed logarithms
      else
         call printstop('order different from 1 or 2 in all_chan')
      endif

      pTH = pTH + stepsize
 1    enddo

      IF(bins) THEN
      OPEN(20,file=outfile,ACCESS='APPEND')   
      OPEN(21,file=outfile_gg,ACCESS='APPEND')   
      OPEN(22,file=outfile_gq,ACCESS='APPEND')   
      OPEN(23,file=outfile_qq,ACCESS='APPEND')   
      write(20,5)'# integral NLO+NLL  (sum*stepsize):',integral_match
      write(20,5)'# integral switched (sum*stepsize):',integral_switch
      write(21,5)'# integral NLO+NLL  (sum*stepsize):',integral_match_gg
      write(21,5)'# integral_switched (sum*stepsize):'
     f ,integral_switch_gg
      write(22,5)'# integral NLO+NLL  (sum*stepsize):',integral_match_gq
      write(22,5)'# integral_switched (sum*stepsize):'
     f ,integral_switch_gq
      write(23,5)'# integral NLO+NLL  (sum*stepsize):',integral_match_qq
      write(23,5)'# integral_switched (sum*stepsize):'
     f ,integral_switch_qq
      if(verbosept.eq.1)then
         write(*,4)'Integral NLO+NLL (sum*stepsize):',integral_match
      elseif(verbosept.eq.2)then
         write(*,5)'integral NLO+NLL  (sum*stepsize):  ',integral_match
         write(*,5)'integral_switched (sum*stepsize):  ',integral_switch
       write(*,5)'integral NLO+NLL  (sum*stepsize):  ',integral_match_gg
      write(*,5)'integral_switched (sum*stepsize):  ',integral_switch_gg
       write(*,5)'integral NLO+NLL  (sum*stepsize):  ',integral_match_gq
      write(*,5)'integral_switched (sum*stepsize):  ',integral_switch_gq
       write(*,5)'integral NLO+NLL  (sum*stepsize):  ',integral_match_qq
      write(*,5)'integral_switched (sum*stepsize):  ',integral_switch_qq
      endif
      ENDIF
      if(verbosept.ne.0)then
         print*,' '
      endif
 4    format(A32,1PE12.5,A4,1PE12.5)
 5    format(A35,1PE12.5,A4,1PE12.5)
 90   format(F7.2,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5
     f )
 80   format(A8,1X,A12,1X,A12,1X,A12,1X,A12,1X,A12
     f )
 1234 format(A15,1PE12.5,1X,A4,1X,1PE12.5) 
 3333 FORMAT(A25,F8.2,A)
      CLOSE(20)
      CLOSE(21)
      CLOSE(22)
      CLOSE(23)
      END

C-}}}
C-{{{ subroutine: gg_chan

      SUBROUTINE gg_chan(N,fixord,err_fo,log_exp,err_le,res,err_res)
      implicit none
      DOUBLE PRECISION fixord,err_fo,log_exp,err_le,res,err_res
     f ,result,err_result,resummed,res_err,fo_gg,fo_err_gg,muFFO,muRenFO
     f ,XL,XU,acc,chi2,integral_switch,integral_match,sum,res_fix_LO
     f ,Shad,Hmass,Hmin,pTH,mV,mT,mb,muF,muRen,Qres,matched,switched
      INTEGER N,ndim,ncall,ncall1,itmx,nprn,itmx1,orderSAVE,i,N_dum
     f ,runscale
      COMMON/BVEG1/XL(10),XU(10),acc,ndim,ncall,itmx,nprn
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-output.f'
      COMMON /IntVars/ Shad,Hmass,Hmin,pTH,mV,mT,mb,N_dum
      COMMON /ScaleVars/ muF,muRen,Qres,muFFO,muRenFO,runscale
      external LO_gg,res_LO_gg

!---  evalutation LO pT distribution
      integral_match  = 0d0
      integral_switch = 0d0
      IF(bins) THEN
         pTH = pT_Hmin
      ELSE
         pT_Hmax=pTH+1
         stepsize=2
      ENDIF
      do 1 while (pTH <= pT_Hmax)
      IF(bins) CALL ParameterOUTandERR()

      IF(runscale .eq. 1) THEN
         muFFO   = dsqrt(Hmass**2 + pTH**2) * muF/Hmass
         muRenFO = dsqrt(Hmass**2 + pTH**2) * muRen/Hmass
         CALL runCouplings(muRen,muRenFO)
      ENDIF

      OPEN(22,file=outfile_gg,ACCESS='APPEND')   

      result = 0d0
      call integrate(LO_gg,2,N*10,10,result,err_result,chi2)
      print *,'LO (gg)   :',result,'  +/-',err_result
      print *,' '
      WRITE(40,*) 'LO (gg)   :',result,'  +/-',err_result

      CALL initial_Itilde(pTH/Qres)
      call initrescoeff()
      res_fix_LO = 0d0

      call integrate(res_LO_gg,2,N*3,10,res_fix_LO,err_result,chi2)
      print *,'Res_LO (gg):',res_fix_LO,'  +/-',err_result
      print *,' '
      WRITE(40,*) 'Res_LO (gg):',res_fix_LO,'  +/-',err_result
      
!      CALL resumINT(N,dum1,dum2,dum3,dum4)
      order     = orderSAVE

      chan = 2 ! 1(all)/2(gg)/3(gq)/4(qq)
      gg_or_qq = 1
      CALL get_resummed(1,resummed,res_err) 

      print *,'Resummed_NLL (gg):',resummed,'  +/-',res_err
      print *,' '
      WRITE(40,*) 'Reesummed_NLL (gg):',resummed,'  +/-',res_err

      matched = result - res_fix_LO + resummed
      if(pTH .gt. Hmass*2d0) then
         switched = result
      elseif(pTH.gt.Hmass*0.5d0 .and. (resummed-res_fix_LO).lt.0d0) then
         switched = result
      else
         switched=matched
      endif

      integral_match = integral_match + matched * stepsize
      integral_switch = integral_switch + switched * stepsize

      write(22,90) pTH,resummed,res_fix_LO,result,matched,switched
      CLOSE(22)
      
      pTH = pTH + stepsize
 1    enddo

      OPEN(22,file=outfile_gg,ACCESS='APPEND')   
      print*,'integral_matched: ',integral_match
      write(22,5)'# integral_matched: ',integral_match
      print*,'integral_switched:',integral_switch
      write(22,5)'# integral_switched:',integral_switch

  5   format(A20,1PE12.5,A4,1PE12.5)
  90  format(F7.2,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5
     f )
      CLOSE(22)
      END

C-}}}
C-{{{ subroutine: gq_chan

      SUBROUTINE gq_chan(N,fixord,err_fo,log_exp,err_le,res,err_res)
      implicit none
      DOUBLE PRECISION fixord,err_fo,log_exp,err_le,res,err_res
     f ,res_err
     f ,XL,XU,acc,chi2,integral_match,integral_switch
     f ,Shad,Hmass,Hmin,pTH,mV,mT,mb,muF,muRen,Qres,matched,switched 
     f le_err_bb,fo_gq,fo_err_gq,switched,muFFO,muRenFO
      INTEGER N,ndim,ncall,ncall1,itmx,nprn,itmx1,orderSAVE,i,N_dum
     f ,runscale 
      COMMON/BVEG1/XL(10),XU(10),acc,ndim,ncall,itmx,nprn
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-output.f'
      COMMON /IntVars/ Shad,Hmass,Hmin,pTH,mV,mT,mb,N_dum
      COMMON /ScaleVars/ muF,muRen,Qres,muFFO,muRenFO,runscale
      external LO_gq,res_LO_gq

!---  evalutation LO pT distribution
      integral_match = 0d0
      integral_switch = 0d0
      IF(bins) THEN
         pTH = pT_Hmin
      ELSE
         pT_Hmax=pTH+1
         stepsize=2
      ENDIF
      do 1 while (pTH <= pT_Hmax)
      IF(bins) CALL ParameterOUTandERR()

      IF(runscale .eq. 1) THEN
         muFFO   = dsqrt(Hmass**2 + pTH**2) * muF/Hmass
         muRenFO = dsqrt(Hmass**2 + pTH**2) * muRen/Hmass
         CALL runCouplings(muRen,muRenFO)
      ENDIF

      OPEN(22,file=outfile_gq,ACCESS='APPEND')   

      call integrate(LO_gq,2,N*30,10,fixord,err_fo,chi2)
      print *,'LO (gq+qg)   :',fixord,'  +/-',err_fo
      print *,' '
      WRITE(40,*) 'LO (gq+qg)   :',fixord,'  +/-',err_fo

      CALL initial_Itilde(pTH/Qres)
      call initrescoeff()
      call integrate(res_LO_gq,2,N*10,10,log_exp,err_le,chi2)
      print *,'Res_LO (gq+qg):',log_exp,'  +/-',err_le
      print *,' '
      WRITE(40,*) 'Res_LO (gq+qg):',log_exp,'  +/-',err_le
      
!      CALL resumINT(N,dum1,dum2,dum3,dum4)

      chan = 3 ! 1(all)/2(gg)/3(gq)/4(qq)
      gg_or_qq = 1
      CALL get_resummed(1,res,res_err) 
      print *,'Resummed_NLL (gq+qg):',res,'  +/-',res_err
      print *,' '
      WRITE(40,*) 'Reesummed_NLL (gq+qg):',res,'  +/-',res_err

      matched = fixord - log_exp + res
      if(pTH .gt. Hmass*2d0) then
         switched = fixord
      elseif(pTH.gt.Hmass*0.5d0 .and. (res-log_exp).lt.0d0) then
         switched = fixord
      else
         switched = matched
      endif

      integral_match = integral_match + matched * stepsize
      integral_switch = integral_switch + switched * stepsize

      write(22,90) pTH,res,log_exp,fixord,matched,switched
      CLOSE(22)
      
      pTH = pTH + stepsize
 1    enddo

      OPEN(22,file=outfile_gq,ACCESS='APPEND')   
      print*,'integral_matched: ',integral_match
      write(22,5)'# integral_matched: ',integral_match
      print*,'integral_switched:',integral_switch
      write(22,5)'# integral_switched:',integral_switch

  5   format(A20,1PE12.5,A4,1PE12.5)
  90  format(F7.2,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5
     f )
      CLOSE(22)
      END

C-}}}
C-{{{ subroutine: qq_chan

      SUBROUTINE qq_chan(N,fixord,err_fo,log_exp,err_le,res,err_res)
      implicit none
      DOUBLE PRECISION fixord,err_fo,log_exp,err_le,res,err_res,mb
     f ,res_err,fo_bq,fo_err_bq,chi2,Shad,Hmass,Hmin,pTH,mV,mT,orderSAVE
     f ,matched,switched,integral_match,integral_switch 
     f ,muF,muRen,Qres,muFFO,muRenFO 
      INTEGER N,N_dum,runscale
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-cuts.f'
      include 'Commons/common-output.f'
      COMMON /ScaleVars/ muF,muRen,Qres,muFFO,muRenFO,runscale
      COMMON /IntVars/ Shad,Hmass,Hmin,pTH,mV,mT,mb,N_dum
      external LO_qq

!---  evalutation LO pT distribution
      integral_match = 0d0
      integral_switch = 0d0
      IF(bins) THEN
         pTH = pT_Hmin
      ELSE
         pT_Hmax=pTH+1
         stepsize=2
      ENDIF
      do 1 while (pTH <= pT_Hmax)
      IF(bins) CALL ParameterOUTandERR()

      IF(runscale .eq. 1) THEN
         muFFO   = dsqrt(Hmass**2 + pTH**2) * muF/Hmass
         muRenFO = dsqrt(Hmass**2 + pTH**2) * muRen/Hmass
         CALL runCouplings(muRen,muRenFO)
      ENDIF

      OPEN(22,file=outfile_qq,ACCESS='APPEND')   

      call integrate(LO_qq,2,N*10,10,fixord,err_fo,chi2)
      print *,'LO (qq)   :',fixord,'  +/-',err_fo
      print *,' '
      WRITE(40,*) 'LO (qq)   :',fixord,'  +/-',err_fo

      res = 0d0
      log_exp = 0d0
      matched = fixord
      switched = fixord

      integral_match = integral_match + matched * stepsize
      integral_switch = integral_switch + switched * stepsize

      write(22,90) pTH,res,log_exp,fixord,matched,switched
      CLOSE(22)
      
      pTH = pTH + stepsize
 1    enddo

      OPEN(22,file=outfile_qq,ACCESS='APPEND')   
      print*,'integral_matched: ',integral_match
      write(22,5)'# integral_matched: ',integral_match
      print*,'integral_switched:',integral_switch
      write(22,5)'# integral_switched:',integral_switch

  5   format(A20,1PE12.5,A4,1PE12.5)
  90  format(F7.2,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5,1X,1PE12.5
     f )
      CLOSE(22)

      END

C-}}}

C-{{{ function: LO_gg

      DOUBLE PRECISION FUNCTION LO_gg(x)
      implicit none
      DOUBLE PRECISION x(10),alpha_sFO,Hbb,PDFsgg,Sigma_0,z,pTmH,y,get_y
     f ,sman,tman,uman,AMPLO,AMPgg,fprime,get_y2
     f , LO_gg_htl
     f ,AMP,AMP1,AMP2,pre,max
      include 'Commons/common-cuts.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-fraction.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-order.f'
c      include 'Commons/common-quark.f'
      INTEGER k,j

      LO_gg = 0d0

      z = x(1)
      eta2 = x(2)
      eta1 = Hmass**2/z/eta2/Shad
      IF(eta1 >= 1d0) RETURN
      pTmH = pTH/Hmass

      IF(z >= 1d0
     f     - 2d0*pTmH * (dsqrt(1+pTmH**2)-pTmH))RETURN
      sman = eta1*eta2*Shad
      fprime = dsqrt(1-4*z/(1-z)**2*pTmH**2)*sman*(1-z)      
      sigma_0 =alpha_sFO(order)**2/Pii/vev**2/288.d0/2d0*AMPLO(Hmass**2)

      y = get_y(eta1,eta2,pTH,Hmass,Shad)
      IF(y .eq. 100d0) RETURN
      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)
c      QCDLOOP =.false.
c      Int2    =.false.
c      Int3    =.false.
      pre=-1d0

      if(pTH .lt.0.001d0) then
         call printstop('AMPgg: pTH < 0.001 not reliable result')
      endif

      AMP = AMPgg(sman,tman,uman)

      LO_gg = sigma_0 * alpha_sFO(order) * AMP
     f * 48d0 * z/2d0
     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
     f /8d0/Pii                  ! dpT dy phase-space
     f * 2d0                     ! y1+y2
     f / fprime                  ! y integration

c$$$      AMP1=AMPgg(sman,tman,uman)
c$$$
c$$$      k=k+1
c$$$      AMP2=AMP
c$$$      IF(dabs(AMP1-AMP2) .gt. dabs(0.0001d0*AMP1)) then
c$$$      print*,'--------------------------------------------------'
c$$$      print*,k
c$$$         print*,'QCDLOOP:',AMP1
c$$$         print*,'NORMAL :',AMP2
c$$$         print*,AMPgg(sman,tman,uman)
c$$$         print*,AMPgg(sman,tman,uman)
c$$$         print*,AMPgg(sman,tman,uman)
c$$$         print*,AMPgg(sman,tman,uman)
c$$$         print*,'RATIO  :',AMP1/AMP2
c$$$         print*,sman,tman,uman
c$$$         print*,eta1,eta2
c$$$         print*,y
c$$$         if(dabs(tman) .gt. dabs(max)) max =tman
c$$$         print*,max,tman,max/pTH**2
c$$$         QCDLOOP=.false.
c$$$         if(dabs(tman) < pre*pTH**2 .and. pre .ne. -1d0) then
c$$$            QCDLOOP=.true.
c$$$         endif
c$$$         print*,QCDLOOP,pre
c$$$      ENDIF
 
!      stop

c$$$      LO_gg_htl = 32d0/(3d0*Pii) * ((sman+tman+uman)**4+sman**4+tman**4
c$$$     f +uman**4)/sman/tman/uman /(2d0*sman) !* AMPLO(Hmass**2)
c$$$     f * alpha_sFO(order)**3*gF*dsqrt(2d0)
c$$$     f /256d0
c$$$     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
c$$$     f /8d0/Pii                  ! dpT dy phase-space
c$$$     f * 2d0                     ! y1+y2
c$$$     f / fprime                  ! y integration
c$$$      LO_gg = LO_gg_htl

      LO_gg = LO_gg * PDFsgg(eta1,eta2,muFFO,order)
      LO_gg = LO_gg * GeVpb *(Hmass**2/z**2/eta2/Shad)

      END

C-}}}
C-{{{ function: LO_gq

      DOUBLE PRECISION FUNCTION LO_gq(x)
      implicit none
      DOUBLE PRECISION x(10),alpha_sFO,Hbb,PDFsgq,Sigma_0,z,s,pTmH,y
     f ,get_y,sman,tman,uman,AMPLO,AMPqg,fprime,get_y2,AMP
      include 'Commons/common-cuts.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-fraction.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-order.f'
c      include 'Commons/common-quark.f'

c      QCDLOOP =.true.
c      Int2    =.true.
c      Int3    =.true.
      LO_gq = 0d0
      AMP = 0d0

      z = x(1)
      eta2 = x(2)
      eta1 = Hmass**2/z/eta2/Shad
      IF(eta1 > 1d0) RETURN
      pTmH = pTH/Hmass

      IF(z >= 1d0 - 2*pTmH * (dsqrt(1+pTmH**2)-pTmH)) RETURN
      sman = eta1*eta2*Shad
      fprime = dsqrt(1-4*z/(1-z)**2*pTmH**2)*sman*(1-z)      
      sigma_0 =alpha_sFO(order)**2/Pii/vev**2/288.d0/2d0*AMPLO(Hmass**2)

      y = get_y(eta1,eta2,pTH,Hmass,Shad)
      IF(y .eq. 100d0) THEN
         call printwarn('LO_gq: y1 = NaN - skipping event')
         RETURN
      ENDIF
      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)
      AMP = AMPqg(sman,uman,tman)         !uman<->tman switched => gq

      y = get_y2(eta1,eta2,pTH,Hmass,Shad)
      IF(y .eq. 100d0) THEN
         call printwarn('LO_gq: y2 = NaN - skipping event')
         RETURN
      ENDIF
      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)
      AMP = AMP + AMPqg(sman,uman,tman)   !uman<->tman switched => gq
      
      LO_gq = sigma_0 * alpha_sFO(order) * AMP 
     f * 32d0/3d0 * z/2d0
     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
     f /8d0/Pii                  ! dpT dy phase-space
     f / fprime                  ! y integration
     f * 2d0                     ! gq+qg

c$$$      y = get_y(eta1,eta2,pTH,Hmass,Shad)
c$$$      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
c$$$      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)
c$$$      LO_gq = -16d0/(9d0*Pii)*(sman**2+tman**2)/uman * AMPLO(Hmass**2)
c$$$     f /(2d0*sman) 
c$$$     f * alpha_sFO(order)**3*gF*dsqrt(2d0)
c$$$     f /4d0/24d0
c$$$     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
c$$$     f /8d0/Pii                  ! dpT dy phase-space
c$$$     f * 2d0                     ! y1+y2
c$$$     f / fprime                  ! y integration
c$$$
c$$$      y = get_y2(eta1,eta2,pTH,Hmass,Shad)
c$$$      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
c$$$      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)
c$$$      LO_gq =LO_gq-16d0/(9d0*Pii)*(sman**2+tman**2)/uman*AMPLO(Hmass**2)
c$$$     f /(2d0*sman) 
c$$$     f * alpha_sFO(order)**3*gF*dsqrt(2d0)
c$$$     f /4d0/24d0
c$$$     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
c$$$     f /8d0/Pii                  ! dpT dy phase-space
c$$$     f * 2d0                     ! y1+y2
c$$$     f / fprime                  ! y integration
      
      LO_gq = LO_gq * PDFsgq(eta1,eta2,muFFO,order)
      LO_gq = LO_gq * GeVpb *(Hmass**2/z**2/eta2/Shad)

      END

C-}}}
C-{{{ function: LO_qq

      DOUBLE PRECISION FUNCTION LO_qq(x)
      implicit none
      DOUBLE PRECISION x(10),alpha_sFO,Hbb,PDFsqqbar,Sigma_0,z,pTmH
     f ,get_y,y,sman,tman,uman,AMPLO,AMPqq,fprime,get_y2 
      include 'Commons/common-cuts.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-fraction.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-order.f'

      LO_qq = 0d0

      z = x(1)
      eta2 = x(2)
      eta1 = Hmass**2/z/eta2/Shad
      IF(eta1 > 1d0) RETURN
      pTmH = pTH/Hmass

      IF(z >= 1d0 - 2d0*pTmH * (dsqrt(1+pTmH**2)-pTmH)) RETURN
      y = get_y(eta1,eta2,pTH,Hmass,Shad)
      IF(y .eq. 100d0) THEN
         call printwarn('LO_gq: y1 = NaN - skipping event')
         RETURN
      ENDIF

      sman = eta1*eta2*Shad
      tman = Hmass**2-dsqrt(Shad)*eta2*dsqrt(Hmass**2 + pTH**2)*dexp(y)
      uman = Hmass**2-dsqrt(Shad)*eta1*dsqrt(Hmass**2 + pTH**2)*dexp(-y)

      fprime = dsqrt(1-4*z/(1-z)**2*pTmH**2)*sman*(1-z)
      sigma_0 =alpha_sFO(order)**2/Pii/vev**2/288.d0/2d0*AMPLO(Hmass**2)

      LO_qq = sigma_0 * alpha_sFO(order) * AMPqq(sman,tman+uman)
     f * (tman**2+uman**2)/(tman+uman)**2*(1-z)**2/z
     f * 24d0 * 32d0/27d0 * z/2d0
     f * 2d0 * pTH               ! dsigma/dpT^2 -> dsigma/dpT 
     f /8d0/Pii                  ! dpT dy phase-space
     f * 2d0                     ! y1+y2
     f / fprime                  ! y integration

      LO_qq = LO_qq * PDFsqqbar(eta1,eta2,muFFO,order)
      LO_qq = LO_qq * GeVpb *(Hmass**2/z**2/eta2/Shad)

      END

C-}}}

C-{{{ function: res_LO_gg

      DOUBLE PRECISION FUNCTION res_LO_gg(x)
      implicit none
      DOUBLE PRECISION x(10),alpha_s,Hbb,PDFsgg,Sigma_0,z,pTQ,pTmH
     f ,Sig11_gg,Sig12_gg,Itilde,PDFz,PDF1,Htheta,lnR,lnF,lnQ
     f ,P_gg_const,P_gg_delta,P_gg_plus,AMPLO
     f ,abisq 
      include 'Commons/common-cuts.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-fraction.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      res_LO_gg = 0d0

      z = x(1)
      eta2 = x(2)
      eta1 = Hmass**2/z/eta2/Shad
      pTQ = pTH/Qres
      pTmH = pTH/Hmass

!      IF(eta1 > 1d0) RETURN
      IF(eta1*eta2*Shad < Hmass**2) RETURN
!      IF(z >= 1d0 - 2*pTQ * (dsqrt(1+pTQ**2)-pTQ)) RETURN

      lnR = dlog( muRen**2 / Qres**2 )
      lnF = dlog( muF**2   / Qres**2 )
      lnQ = dlog( Hmass**2 / Qres**2 )

      PDFz = PDFsgg(eta1,eta2,muF,order)
      PDF1 = PDFsgg(Hmass**2/eta2/Shad,eta2,muF,order)

      Sig12_gg = - A1_g/2d0 * PDF1            !delta(1-z)
      Sig11_gg = - (B1_g + A1_g * lnQ) * PDF1  !delta(1-z)
     f     - P_gg_delta(z) * PDF1            !delta(1-z)
     f     - P_gg_const(z) * PDFz/z        !z-dependend
     f     - P_gg_plus(z) * (PDFz/z-PDF1)  !z-dependend

      sigma_0 =alpha_s(order)**2/Pii/vev**2/288.d0/2d0 * AMPLO(Hmass**2)

      res_LO_gg = sigma_0 * alpha_s(order)/Pii * 1d0/Qres**2
     f * (Sig12_gg * Itilde(2,pTQ)
     f     +  Sig11_gg * Itilde(1,pTQ)) *(Hmass**2/eta2/Shad)
      res_LO_gg = res_LO_gg * GeVpb 
! dpT^2 = 2*pT dpT
      res_LO_gg = res_LO_gg * 2d0 * pTH
      END

C-}}}
C-{{{ function: res_LO_gq

      DOUBLE PRECISION FUNCTION res_LO_gq(x)
      implicit none
      DOUBLE PRECISION x(10),alpha_s,Hbb,PDFsgq,Sigma_0,z,pTQ,pTmH
     f ,Sig11_gq,Itilde,PDFz,PDF1,Htheta,lnR,lnF,lnQ,P_qg,AMPLO
      include 'Commons/common-cuts.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-fraction.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-order.f'
      include 'Commons/common-rescoeff.f'
      res_LO_gq = 0d0

      z = x(1)
      eta2 = x(2)
      eta1 = Hmass**2/z/eta2/Shad
      IF(eta1 > 1d0) RETURN
      pTQ = pTH/Qres
      pTmH = pTH/Hmass

!      IF(eta1*eta2*Shad < Hmass**2) RETURN
!      IF(z >= 1d0 - 2*pTQ * (dsqrt(1+pTQ**2)-pTQ)) RETURN

      lnR = dlog( muRen**2 / Qres**2 )
      lnF = dlog( muF**2   / Qres**2 )
      lnQ = dlog( Hmass**2 / Qres**2 )

      PDFz = PDFsgq(eta1,eta2,muF,order) * 2d0 ! gq+qg
      
      Sig11_gq = - P_qg(z)/2d0 * PDFz/z

      sigma_0 =alpha_s(order)**2/Pii/vev**2/288.d0/2d0 * AMPLO(Hmass**2)

      res_LO_gq = Sigma_0 * alpha_s(order)/Pii * 1d0/Qres**2
     f     * Sig11_gq * Itilde(1,pTQ) *(Hmass**2/eta2/Shad)
      res_LO_gq = res_LO_gq * GeVpb 
! dpT^2 = 2*pT dpT
      res_LO_gq = res_LO_gq * 2d0 * pTH
      END

C-}}}
C-{{{ subroutine: initial_Itilde

      SUBROUTINE initial_Itilde(z)
      implicit none
      DOUBLE PRECISION z,K0_b0z,K1_b0z,K2_b0z,K3_b0z,error,chi2,IK_alt
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-constants.f'
      include 'Commons/common-rescoeff.f'
      external K0_b0z_dt,K1_b0z_dt,K2_b0z_dt,K3_b0z_dt
      z_Itilde = z

      IF(z > 50d0) THEN
         Itilde_1 = 0d0
         Itilde_2 = 0d0
      ELSEIF(z >= 0.00005d0) THEN
c$$$         Itilde_1 = (1d0/2d0) * IK_alt(1)*Qres**2
c$$$         Itilde_2 = (1d0/4d0) * IK_alt(2)*Qres**2*2d0

         K0_b0z = 0d0
         K1_b0z = 0d0
         CALL integrate(K0_b0z_dt,11,2000000,20,K0_b0z,error,chi2)
         do while(K0_b0z .ne. K0_b0z)
            CALL integrate(K0_b0z_dt,11,2000000,20,K0_b0z,error,chi2)
         enddo
         Itilde_1 = - b0/z * K0_b0z
         CALL integrate(K1_b0z_dt,11,1000000,20,K1_b0z,error,chi2)
         do while(K1_b0z .ne. K1_b0z)
            CALL integrate(K1_b0z_dt,12,1000000,20,K1_b0z,error,chi2)
         enddo
         Itilde_2 = 2d0*b0/z * ( K0_b0z * dlog(z) - K1_b0z )
      ELSE
         Itilde_1 = - 1d0/z**2
         Itilde_2 = - 2d0/z**2 * dlog(1/z**2)
      ENDIF

!      print *,'Itilde_1(z=',z,')= ', Itilde_1
!      print *,'Itilde_2(z=',z,')= ', Itilde_2
!      print *,'Itilde_1(z=',z,')/Qres^2= ', Itilde_1/Qres**2
!      print *,'Itilde_2(z=',z,')/Qres^2= ', Itilde_2/Qres**2
!      print *,'K_1^0(z=',z,')= ', K0_b0z
!      print *,'K_1^1(z=',z,')= ', K1_b0z
!      print *,' '
!      Itilde_2
!      Itilde_3
!      Itilde_4
      Itilde_set = 1
      END

C-}}}
C-{{{ function: K0_b0z_dt

      DOUBLE PRECISION FUNCTION K0_b0z_dt(x)
      implicit none
      DOUBLE PRECISION x(10),t
      include 'Commons/common-constants.f'
      include 'Commons/common-rescoeff.f'
      K0_b0z_dt = 0d0
      
      t = x(1)

      K0_b0z_dt = dexp(-b0 * z_Itilde * dcosh(x(1))) * dcosh(t)
      END
 
C-}}}
C-{{{ function: K1_b0z_dt

      DOUBLE PRECISION FUNCTION K1_b0z_dt(x)
      implicit none
      DOUBLE PRECISION x(10),t
      include 'Commons/common-constants.f'
      include 'Commons/common-rescoeff.f'
      K1_b0z_dt = 0
      
      t = x(1)

      K1_b0z_dt = 1/b0/z_Itilde * dexp(-b0 * z_Itilde * dcosh(t))
      END

C-}}}
C-{{{ function: Itilde

      DOUBLE PRECISION FUNCTION Itilde(n,x)
      implicit none
      DOUBLE PRECISION x
      INTEGER n
      include 'Commons/common-rescoeff.f'
      Itilde = 0d0
      
      IF(Itilde_set == 1) THEN
         IF(n == 1) THEN
            Itilde = Itilde_1
            RETURN
         ELSEIF(n == 2) THEN
            Itilde = Itilde_2
            RETURN
         ELSE
            call printstop('wrong Integral number n in function:Itilde')
         ENDIF
         RETURN
      ENDIF

      IF(n == 1) THEN
         Itilde = - 1d0/x**2
         RETURN
      ELSEIF(n == 2 .or. n == 3 .or. n == 4) THEN
         Itilde = - dble(n)/x**2 * dlog(1/x**2)**(n-1)
         RETURN
      ELSE
         call printstop('wrong Integral number n in function:Itilde')
      ENDIF
      END

C-}}}
C-{{{ function: IK_alt

      function IK_alt(m)
      implicit none
      external BK
      real *8 BK,IK_alt,argum,dloqt
      integer m
      include 'Commons/common-constants.f'
      include 'Commons/common-scalesintvars.f'
      include 'Commons/common-rescoeff.f'

      argum=b0*pTH/Qres
      dloqt=DLOG(pTH/Qres)
      
      

      if (m.eq.1) then
         IK_alt=-(2*b0/Qres/pTH)*BK(0,argum)
      elseif (m.eq.2) then
         IK_alt=-(4*b0/Qres/pTH)*(BK(1,argum)-BK(0,argum)*DLOqt)
      elseif (m.eq.3) then
         IK_alt=(b0/Qres/pTH)*(-6*BK(2,argum)+12*BK(1,argum)*DLOqt+
     /                 BK(0,argum)*(Pii**2-6*(DLOqt**2)))
      elseif (m.eq.4) then
         IK_alt=-(4*b0/Qres/pTH)*(2*BK(3,argum)-6*DLOqt*BK(2,argum)+
     /                    BK(1,argum)*(6*(DLOqt)**2-Pii**2)+
     /                    BK(0,argum)*(Pii**2*DLOqt-
     /                                 2*(DLOqt)**3-4*zeta3))
      endif


      return
      end

C-}}}
C-{{{ subroutine: initrescoeff

      SUBROUTINE initrescoeff()
      implicit none
      include 'Commons/common-rescoeff.f'
      include 'Commons/common-constants.f'
      
      A1_q = cF
      A2_q = cF/2d0 * ((67d0/18d0-Pii**2/6d0)*cA-10d0/9d0*nf*tR)
      B1_q = -3d0/2d0 * cF
      B2_q = 1d0

      A1_g = cA
      A2_g = cA/2d0 * ((67d0/18d0-Pii**2/6d0)*cA-10d0/9d0*nf*tR)
      B1_g = -beta0
      B2_g = 1d0
      END

C-}}}

C-{{{ FUNCTION: get_y

      DOUBLE PRECISION FUNCTION get_y(x1,x2,pT,m,Shad)
      implicit none
      DOUBLE PRECISION x1,x2,pT,m,Shad

      IF((m**2 + pT**2)*(m**4 - 2*m**2*Shad*x1*x2 
     f     + Shad*x1*x2*(-4*pT**2 + Shad*x1*x2)) .lt. 0d0) THEN
         get_y = 100d0
         return
      ENDIF

      get_y = dlog((dsqrt(m**2 + pT**2)*(m**2 + Shad*x1*x2) - 
     f     dsqrt((m**2 + pT**2)*(m**4 - 2*m**2*Shad*x1*x2 
     f     + Shad*x1*x2*(-4*pT**2 + Shad*x1*x2))))/
     f     (2d0*(m**2 + pT**2)*dsqrt(Shad)*x2))
      END

      DOUBLE PRECISION FUNCTION get_y2(x1,x2,pT,m,Shad)
      implicit none
      DOUBLE PRECISION x1,x2,pT,m,Shad

      get_y2 = dlog((dsqrt(m**2 + pT**2)*(m**2 + Shad*x1*x2) +
     f     dsqrt((m**2 + pT**2)*(m**4 - 2*m**2*Shad*x1*x2 
     f     + Shad*x1*x2*(-4*pT**2 + Shad*x1*x2))))/
     f     (2d0*(m**2 + pT**2)*dsqrt(Shad)*x2))
      END

C-}}}
