C-{{{ function pdfs(xx,rmuf):

      subroutine pdfs(xx,rmuf,up,ubar,dn,dbar,str,sbar,
     &     chm,cbar,bot,bbar,glu)
c..
c..   interface to LHAPDF, by rh
c..
      implicit real*8 (a-z)
      real*8 ff(-6:6)
      integer neigen,alphasorder,alphasnfmax,nset
      parameter(neigen=20)      ! number of eigenvectors
      double precision dn,dbar,up,ubar,str,sbar,
     &     chm,cbar,bot,bbar,glu,phot,distance,tolerance,
     &     mcharm,mbottom,alphasq0,alphasmz
      character prefix*80
      include 'Commons/common-pdfvals.f'
      include 'Commons/common-order.f'

      xxl = xx
      rmufl = rmuf
      nset = order+1
c..   this is the LHAPDF subroutine to evaluate the pdfs:
      call evolvepdfm(nset,xxl,rmufl,ff)

      dn = ff(1)/xx
      dbar = ff(-1)/xx
      up = ff(2)/xx
      ubar = ff(-2)/xx
      str = ff(3)/xx
      sbar = ff(-3)/xx
      chm = ff(4)/xx
      cbar = ff(-4)/xx
      bot = ff(5)/xx
      bbar = ff(-5)/xx
      glu = ff(0)/xx

      end

C-}}}
